using System;
using CSWrap;

class CineScript
{
    static WorldVehicle lambo;
    static float start;

    public static void Init(WorldContainer wct)
    {
        WorldDate time = new WorldDate();
        time.Year = 1999;
        time.Day = 0;
        time.DayTime = WorldDate.GetSecondsPerDay() * 0.5f;

        wct.SetTime(time);

        uint resid = resid = ObjectDatabase.CalcFullID(ODBRESSOURCETYPE.ORT_VEHICLE, 123);
        WorldCoordinate pos = new WorldCoordinate(0, 0, 415.0f, 295.0f);
        DXMatrix m = DXMatrix.IDENTITY();
        m.Set(3,2, wct.GetZ(pos) + 0.5f);
        lambo = wct.AddVehicle(pos, resid, m);

        lambo.SetAutomaticGearBoxEnable(true);
        lambo.SetCruiseControl(15);
        lambo.FollowPath(wct.GetWayPointSystem().GetPath(new XString("test")));

        start = wct.GetTime().DayTime;
    }

    public static void Update(WorldContainer wct)
    {
        float cinetick = wct.GetTime().DayTime - start;
        if (cinetick > 18)
             lambo.SetCruiseControl(5);
            
    }

    public static void Finalize(WorldContainer wct)
    {
        wct.DeleteObj(lambo);
    }
 }
