using System;
using System.Collections.Generic;
using CSWrap;

class CineScript
{
    static List<WorldObject> g_DemoObjects = new List<WorldObject>();

    static WorldVehicle lambo = null;
    static MapObject lamboobj = null;
    static float start = 0;
    static float g_FarPlaneRestore = 2000;

    static CSWrap.Image g_Overlay;
    static CSWrap.Image g_DemoText1;
    static CSWrap.Image g_DemoText2;
    static CSWrap.Image g_DemoText3;
    static CSWrap.Image g_DemoText4;
    static CSWrap.Menu g_Menu;

    public static void CreateLambo(WorldContainer wct, MapView mv)
    {
        uint resid = ObjectDatabase.CalcFullID(ODBRESSOURCETYPE.ORT_VEHICLE, 123);
        WorldCoordinate pos = new WorldCoordinate(3, 3, 380.0f, 115.0f);
        DXMatrix m = DXMatrix.RotationZ(-1.57f);
        m.Set(3, 2, wct.GetZ(pos) + 0.5f);
        lambo = wct.AddVehicle(pos, resid, m);
        g_DemoObjects.Add((WorldObject)lambo);

        lambo.SetAutomaticGearBoxEnable(true);
        lambo.SetCruiseControl(15);
        lambo.FollowPath(wct.GetWayPointSystem().GetPath(new XString("CourseCW")));

        //get first probe and set its update skip
        mv.GetMapBlockGlobal(3, 3).ProcessEvents(); // call process events to create object instance
        lamboobj = mv.GetObjectInstance(lambo);
        MapVehicle vh = lamboobj.IsMapVehicle();
        vh.GetMeshInstance().GetProbeSource(0).IsEnvironmentMapSource().SetSkipFrames(3); //every third frame
    }

    public static void CreateMenuStuff(MapView mv)
    {
        g_Overlay = new CSWrap.Image(mv.GetMenuManager(), 2);
        GC.SuppressFinalize(g_Overlay);
        g_Overlay.SetTexture(mv.GetDevice().GetTextureManager().CreateTexture(new XString("GFX\\Menu\\nothing.bmp"), FORMAT.FMT_L8, POOL.POOL_MANAGED));
        g_Overlay.SetSize(mv.GetViewPort().GetWidth(), mv.GetViewPort().GetHeight());
        g_Overlay.SetAlphaTest(true);
        g_Overlay.SetAlphaBlend(true);
        //        g_Overlay.SetOpacity(0.95f);

        g_DemoText1 = new CSWrap.Image(mv.GetMenuManager(), 2);
        GC.SuppressFinalize(g_DemoText1);
        g_DemoText1.SetTexture(mv.GetDevice().GetTextureManager().CreateTexture(new XString("GFX\\Menu\\DT_somewhere.png"), FORMAT.FMT_A8R8G8B8, POOL.POOL_MANAGED));
        g_DemoText1.SetSize(512, 64);
        g_DemoText1.SetPosition(150, 300);

        g_DemoText2 = new CSWrap.Image(mv.GetMenuManager(), 2);
        GC.SuppressFinalize(g_DemoText2);
        g_DemoText2.SetTexture(mv.GetDevice().GetTextureManager().CreateTexture(new XString("GFX\\Menu\\DT_realtime.png"), FORMAT.FMT_A8R8G8B8, POOL.POOL_MANAGED));
        g_DemoText2.SetSize(512, 64);
        g_DemoText2.SetPosition(150, 300);

        g_DemoText3 = new CSWrap.Image(mv.GetMenuManager(), 2);
        GC.SuppressFinalize(g_DemoText3);
        g_DemoText3.SetTexture(mv.GetDevice().GetTextureManager().CreateTexture(new XString("GFX\\Menu\\DT_demoby.png"), FORMAT.FMT_A8R8G8B8, POOL.POOL_MANAGED));
        g_DemoText3.SetSize(512, 64);
        g_DemoText3.SetPosition(150, 300);

        g_DemoText4 = new CSWrap.Image(mv.GetMenuManager(), 2);
        GC.SuppressFinalize(g_DemoText4);
        g_DemoText4.SetTexture(mv.GetDevice().GetTextureManager().CreateTexture(new XString("GFX\\Menu\\DT_continue.png"), FORMAT.FMT_A8R8G8B8, POOL.POOL_MANAGED));
        g_DemoText4.SetSize(333, 64);
        g_DemoText4.SetPosition(150, 300);

        g_Menu = new CSWrap.Menu(mv.GetMenuManager(), 1);
        GC.SuppressFinalize(g_Menu);
        g_Menu.AddChild(g_Overlay);

        mv.GetMenuManager().AddMenu(g_Menu);
    }

    public static void Init(WorldContainer wct, MapView mv)
    {
        WorldDate time = new WorldDate();
        time.Year = 1999;
        time.Day = 0;
        time.DayTime = WorldDate.GetSecondsPerDay() * 0.45f;

        wct.SetTime(time);

        CreateLambo(wct, mv);

        start = wct.GetTime().DayTime;

        CreateMenuStuff(mv);

        g_FarPlaneRestore = mv.GetFarPlane();
        mv.SetFarPlane(1500);

        dtw = new bool[] { false, false, false, false, false, false, false, false };
        fhouse = false;
        h2 = false;
    }

    static bool[] dtw = { false, false, false, false, false, false, false, false };
    static bool fhouse = false;
    static bool h2 = false;

    public static void Update(WorldContainer wct, MapView mv)
    {
        float cinetick = wct.GetTime().DayTime - start;

        if (cinetick < 40)
        {
            //nothing, text1, lambo, over, text2, lambo, over, text3, lambo
            float[] ev = { 5.5f, 3, 0.5f, 4, 4, 0.5f, 4, 5 };
            float[] tw = new float[9];
            tw[0] = 4;
            for (int i = 1; i < 9; i++)
                tw[i] = tw[i - 1] + ev[i - 1];

            if (cinetick > tw[0] && cinetick <= tw[1])
            {
                //TEXT: somewhere
                if (!dtw[0])
                {
                    g_Overlay.AddChild(g_DemoText1);
                    dtw[0] = true;
                }
            }
            else if (cinetick > tw[1] && cinetick <= tw[2])
            {
                //lambo driveby
                if (!dtw[1])
                {
                    wct.SetOceanEnable(false);
                    MapVehicle vh = lamboobj.IsMapVehicle();
                    vh.GetMeshInstance().GetProbeSource(0).IsEnvironmentMapSource().SetSkipFrames(30000); //every third frame

                    g_Overlay.RemoveAllChilds();
                    g_Overlay.SetVisible(false);
                    dtw[1] = true;
                }
            }
            else if (cinetick > tw[2] && cinetick <= tw[3])
            {
                //show overlay
                if (!dtw[2])
                {
                    g_Overlay.SetVisible(true);
                    dtw[2] = true;
                }
            }
            else if (cinetick > tw[3] && cinetick <= tw[4])
            {
                //TEXT: realtime rendering demo 07/08
                if (!dtw[3])
                {
                    g_Overlay.AddChild(g_DemoText2);
                    dtw[3] = true;
                }
            }
            else if (cinetick > tw[4] && cinetick <= tw[5])
            {
                //lambo follow
                if (!dtw[4])
                {
                    g_Overlay.RemoveAllChilds();
                    g_Overlay.SetVisible(false);
                    dtw[4] = true;
                }
            }
            else if (cinetick > tw[5] && cinetick <= tw[6])
            {
                //show overlay
                if (!dtw[5])
                {
                    g_Overlay.SetVisible(true);
                    dtw[5] = true;
                }
            }
            else if (cinetick > tw[6] && cinetick <= tw[7])
            {
                //TEXT: demo by
                if (!dtw[6])
                {
                    g_Overlay.AddChild(g_DemoText3);
                    dtw[6] = true;
                }
            }
            else if (cinetick > tw[7] && cinetick <= tw[8])
            {
                //lambo closeup
                if (!dtw[7])
                {
                    g_Overlay.RemoveAllChilds();
                    g_Overlay.SetVisible(false);
                    dtw[7] = true;
                }
            }
        }

        if (cinetick >= 70 && cinetick < 90)
        {
            wct.SetOceanEnable(true);
            mv.SetFarPlane(1000);
        }

        if (cinetick >= 112 && cinetick < 115)
        {
            MapVehicle vh = lamboobj.IsMapVehicle();
            vh.GetMeshInstance().GetProbeSource(0).IsEnvironmentMapSource().SetSkipFrames(3); //every third frame

            mv.SetNearPlane(0.3f);
            mv.SetFarPlane(500);
            wct.SetOceanEnable(false);
        }

        if (cinetick >= 115 && cinetick < 118 && !fhouse)
        {
            fhouse = true;
            lambo.FollowPath(wct.GetWayPointSystem().GetPath(new XString("house")));
            lambo.SetCruiseControl(10);
        }

        if (cinetick >= 118 && cinetick < 125)
        {
            lambo.SetCruiseControl(5);
        }

        if (cinetick >= 150 && cinetick < 155)
        {
            mv.SetFarPlane(2000);
        }

        if (cinetick >= 165 && cinetick < 170)
        {
            g_Overlay.RemoveAllChilds();
            g_Overlay.SetVisible(true);
            g_Overlay.SetOpacity((cinetick - 165) / 5.0f);
            mv.SetFarPlane(2000);
        }

        if (cinetick >= 170 && !h2)
        {
            g_Overlay.SetOpacity(1.0f);
            h2 = true;
            g_Overlay.AddChild(g_DemoText4);
        }
    }

    public static void Finalize(WorldContainer wct, MapView mv)
    {
        //foreach (WorldObject obj in g_DemoObjects)
        //    wct.DeleteObj(obj);
        //g_DemoObjects.Clear();
        wct.DeleteObj(lambo);

        mv.GetMenuManager().RemoveMenu(g_Menu);

        //be sure that the overlay has no childs
        g_Overlay.RemoveAllChilds();

        mv.GetMenuManager().DeleteElement(g_Overlay);
        mv.GetMenuManager().DeleteElement(g_DemoText1);
        mv.GetMenuManager().DeleteElement(g_DemoText2);
        mv.GetMenuManager().DeleteElement(g_DemoText3);
        mv.GetMenuManager().DeleteElement(g_DemoText4);
        mv.GetMenuManager().DeleteElement(g_Menu);

        //mv.SetFarPlane(g_FarPlaneRestore);
        mv.SetNearPlane(1);
        mv.SetFarPlane(2000);
        wct.SetOceanEnable(true);
    }
}
