float4x4 matWVP;

texture Texture;
sampler STexture = sampler_state
{
    Texture = <Texture>;
    AddressU = Wrap;
    AddressV = Wrap;
    MipFilter = NONE;
    MagFilter = LINEAR;
    MinFilter = LINEAR;
};

void VSTransform(float3 ipos : POSITION, float2 itc : TEXCOORD0, out float4 opos : POSITION, out float4 otc : TEXCOORD0)
{
	opos = mul(float4(ipos, 1), matWVP);
	otc = opos;
}

float4 PSTexture(float4 tc : TEXCOORD0, float2 screenxy : VPOS) : COLOR
{
//	float2 sctc = screenxy * float2(0.0005, 0.0005) + float2(0.5, 0.5);
//	return float4(sctc  , 0, 1);
float2 sctc = tc.xy / tc.w * float2(0.5, -0.5) + float2(0.5, 0.5);
sctc += 0.5f / float2(1430,905);
//return float4(sctc  , 0, 1);

return float4(tex2D(STexture, sctc).rgb, 1);
}

technique Render
{
    pass P0
    {
        VertexShader = compile vs_3_0 VSTransform();
        PixelShader  = compile ps_3_0 PSTexture();
    }
}