//scattering
float4x4 g_matInvView;
float4x4 g_matVP;
float2 g_ProjMajor;
float3 g_CamPos;
float3 g_PointDir;

#include "Shaders\Scattering.fx"

//sprite
float SpriteSize;
float4 SpriteColor;

texture SpriteTex;
sampler2D sSprite = sampler_state
{
    Texture = <SpriteTex>;
    AddressU = Clamp;
    AddressV = Clamp;
    MipFilter = NONE;
    MagFilter = LINEAR;
    MinFilter = LINEAR;
};

struct VS_OUTPUT
{
    float4 Pos : POSITION;
    float4 Diff : COLOR0;
};

VS_OUTPUT VS(float2 ScreenPos : POSITION)
{
    VS_OUTPUT Out;;

    // transform
    float2 PosOut = ScreenPos * float2(2, -2) - float2(1, -1);
    Out.Pos = float4(PosOut, 0, 1);

    float3 v = float3(PosOut / g_ProjMajor, 1);
    float3 ViewDir = normalize(mul(v, g_matInvView));

//	Out.Diff = float4(ViewDir.xyz * 0.5 + 0.5, 1);
      Out.Diff = float4(InscatterInf(ViewDir, g_CamPos), 1);

	return Out;
}

// PS
float4 PS(VS_OUTPUT In) : COLOR
{
    return In.Diff;
}

void VSSprite(out float4 oPos : POSITION, out float oPSize : PSIZE)
{
      
	oPos = float4(mul(g_PointDir*0.99, g_matVP).xyz, 1);
	oPSize = SpriteSize;
}

float4 PSSprite(float2 TexC : TEXCOORD0) : COLOR
{
	float4 texcol = tex2D(sSprite, TexC);
	return float4(texcol.rgb * SpriteColor.rgb * SpriteColor.a * 0.6f, texcol.a);
	return float4(texcol.rgb * 3, texcol.a);
//	return float4(texcol.rgb * SpriteColor.rgb * SpriteColor.a, texcol.a);
}

float4 PSOne(void) : COLOR
{
      return 1;
}

technique Sky
{
    pass P0
    {
        AlphaBlendEnable = false;
        AlphaTestEnable = false;
        ZWriteEnable = false;
        ZEnable = false;
        CullMode = None;
        
        VertexShader = compile vs_3_0 VS();
        PixelShader = compile ps_3_0 PS();
    }
}

technique SkySprite
{
	pass P0
	{
		ZEnable = false;
		CullMode = NONE;
		AlphaBlendEnable = true;
		AlphaTestEnable = true;
		AlphaRef = 0;
		AlphaFunc = GREATER;
            BlendOp = ADD;
            SrcBlend = SRCALPHA;
            DestBlend = INVSRCALPHA;
		PointSpriteEnable = true;

		VertexShader = compile vs_3_0 VSSprite();
        PixelShader = compile ps_3_0 PSSprite();
	}

      //write 1 to alpha channel
      pass P1
      {
            ZEnable = false;

		ColorWriteEnable = ALPHA;

		AlphaBlendEnable = false;
		AlphaTestEnable = false;

            VertexShader = compile vs_3_0 VSSprite();
            PixelShader = compile ps_3_0 PSOne();
      }
}

